# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['CustomFieldOptionArgs', 'CustomFieldOption']

@pulumi.input_type
class CustomFieldOptionArgs:
    def __init__(__self__, *,
                 datatype: pulumi.Input[str],
                 field: pulumi.Input[str],
                 value: pulumi.Input[str]):
        """
        The set of arguments for constructing a CustomFieldOption resource.
        :param pulumi.Input[str] datatype: The datatype of the field option. Must be one of `string`, `integer`, `float`, `boolean`, `datetime`, or `url`.
        :param pulumi.Input[str] field: The ID of the field.
        :param pulumi.Input[str] value: The allowed value.
        """
        pulumi.set(__self__, "datatype", datatype)
        pulumi.set(__self__, "field", field)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def datatype(self) -> pulumi.Input[str]:
        """
        The datatype of the field option. Must be one of `string`, `integer`, `float`, `boolean`, `datetime`, or `url`.
        """
        return pulumi.get(self, "datatype")

    @datatype.setter
    def datatype(self, value: pulumi.Input[str]):
        pulumi.set(self, "datatype", value)

    @property
    @pulumi.getter
    def field(self) -> pulumi.Input[str]:
        """
        The ID of the field.
        """
        return pulumi.get(self, "field")

    @field.setter
    def field(self, value: pulumi.Input[str]):
        pulumi.set(self, "field", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[str]:
        """
        The allowed value.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[str]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class _CustomFieldOptionState:
    def __init__(__self__, *,
                 datatype: Optional[pulumi.Input[str]] = None,
                 field: Optional[pulumi.Input[str]] = None,
                 value: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CustomFieldOption resources.
        :param pulumi.Input[str] datatype: The datatype of the field option. Must be one of `string`, `integer`, `float`, `boolean`, `datetime`, or `url`.
        :param pulumi.Input[str] field: The ID of the field.
        :param pulumi.Input[str] value: The allowed value.
        """
        if datatype is not None:
            pulumi.set(__self__, "datatype", datatype)
        if field is not None:
            pulumi.set(__self__, "field", field)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def datatype(self) -> Optional[pulumi.Input[str]]:
        """
        The datatype of the field option. Must be one of `string`, `integer`, `float`, `boolean`, `datetime`, or `url`.
        """
        return pulumi.get(self, "datatype")

    @datatype.setter
    def datatype(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "datatype", value)

    @property
    @pulumi.getter
    def field(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the field.
        """
        return pulumi.get(self, "field")

    @field.setter
    def field(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "field", value)

    @property
    @pulumi.getter
    def value(self) -> Optional[pulumi.Input[str]]:
        """
        The allowed value.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "value", value)


class CustomFieldOption(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 datatype: Optional[pulumi.Input[str]] = None,
                 field: Optional[pulumi.Input[str]] = None,
                 value: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        !> This Resource is no longer functional. Documentation is left here for the purpose of documenting migration steps.

        A Custom Field Option is a specific value that can be used for [Custom Fields](https://support.pagerduty.com/docs/custom-fields) that only allow values from a set of fixed option.

        ## Migration

        The `incident_custom_field_option` resource provides similar functionality
        with largely the same arguments and attributes. The only significant change is that the `datatype` argument has been renamed `data_type`
        to match the Public API for the Custom Fields on Incidents feature.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_pagerduty as pagerduty

        sre_environment = pagerduty.CustomField("sreEnvironment",
            datatype="string",
            fixed_options=True)
        dev_environment = pagerduty.CustomFieldOption("devEnvironment",
            field=sre_environment.id,
            datatype="string",
            value="dev")
        stage_environment = pagerduty.CustomFieldOption("stageEnvironment",
            field=sre_environment.id,
            datatype="string",
            value="stage")
        prod_environment = pagerduty.CustomFieldOption("prodEnvironment",
            field=sre_environment.id,
            datatype="string",
            value="prod")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] datatype: The datatype of the field option. Must be one of `string`, `integer`, `float`, `boolean`, `datetime`, or `url`.
        :param pulumi.Input[str] field: The ID of the field.
        :param pulumi.Input[str] value: The allowed value.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CustomFieldOptionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        !> This Resource is no longer functional. Documentation is left here for the purpose of documenting migration steps.

        A Custom Field Option is a specific value that can be used for [Custom Fields](https://support.pagerduty.com/docs/custom-fields) that only allow values from a set of fixed option.

        ## Migration

        The `incident_custom_field_option` resource provides similar functionality
        with largely the same arguments and attributes. The only significant change is that the `datatype` argument has been renamed `data_type`
        to match the Public API for the Custom Fields on Incidents feature.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_pagerduty as pagerduty

        sre_environment = pagerduty.CustomField("sreEnvironment",
            datatype="string",
            fixed_options=True)
        dev_environment = pagerduty.CustomFieldOption("devEnvironment",
            field=sre_environment.id,
            datatype="string",
            value="dev")
        stage_environment = pagerduty.CustomFieldOption("stageEnvironment",
            field=sre_environment.id,
            datatype="string",
            value="stage")
        prod_environment = pagerduty.CustomFieldOption("prodEnvironment",
            field=sre_environment.id,
            datatype="string",
            value="prod")
        ```

        :param str resource_name: The name of the resource.
        :param CustomFieldOptionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CustomFieldOptionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 datatype: Optional[pulumi.Input[str]] = None,
                 field: Optional[pulumi.Input[str]] = None,
                 value: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CustomFieldOptionArgs.__new__(CustomFieldOptionArgs)

            if datatype is None and not opts.urn:
                raise TypeError("Missing required property 'datatype'")
            __props__.__dict__["datatype"] = datatype
            if field is None and not opts.urn:
                raise TypeError("Missing required property 'field'")
            __props__.__dict__["field"] = field
            if value is None and not opts.urn:
                raise TypeError("Missing required property 'value'")
            __props__.__dict__["value"] = value
        super(CustomFieldOption, __self__).__init__(
            'pagerduty:index/customFieldOption:CustomFieldOption',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            datatype: Optional[pulumi.Input[str]] = None,
            field: Optional[pulumi.Input[str]] = None,
            value: Optional[pulumi.Input[str]] = None) -> 'CustomFieldOption':
        """
        Get an existing CustomFieldOption resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] datatype: The datatype of the field option. Must be one of `string`, `integer`, `float`, `boolean`, `datetime`, or `url`.
        :param pulumi.Input[str] field: The ID of the field.
        :param pulumi.Input[str] value: The allowed value.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CustomFieldOptionState.__new__(_CustomFieldOptionState)

        __props__.__dict__["datatype"] = datatype
        __props__.__dict__["field"] = field
        __props__.__dict__["value"] = value
        return CustomFieldOption(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def datatype(self) -> pulumi.Output[str]:
        """
        The datatype of the field option. Must be one of `string`, `integer`, `float`, `boolean`, `datetime`, or `url`.
        """
        return pulumi.get(self, "datatype")

    @property
    @pulumi.getter
    def field(self) -> pulumi.Output[str]:
        """
        The ID of the field.
        """
        return pulumi.get(self, "field")

    @property
    @pulumi.getter
    def value(self) -> pulumi.Output[str]:
        """
        The allowed value.
        """
        return pulumi.get(self, "value")

